=== debian/changelog ===
cgreen (1.2.0-2) unstable; urgency=medium

  * Team upload.
  * Fix symbols file to account for 32/64 bit difference (Closes: #962859)
  * Remove obsolete field Name from debian/upstream/metadata (already present
    in machine-readable debian/copyright).

 -- Raphaël Hertzog <raphael@offensive-security.com>  Fri, 31 Jul 2020 17:25:44 +0200

cgreen (1.2.0-1) unstable; urgency=medium

  [ Alvin Chen ]
  * Initial release (Closes: #950566)

  [ SZ Lin (林上智) ]
  * d/control:
    - Add VCS information
    - Update Uploaders field
  * d/copyright:
    - Update copyright information

 -- SZ Lin (林上智) <szlin@debian.org>  Sat, 29 Feb 2020 20:48:21 +0800
